.include "2313def.inc"


	.def	Temp1=R16
	.def	Temp2=R17
	.def	Temp3=R18
	.def	Temp4=R19
	.def	Temp=R20

.dseg

Digit:     .byte 4
.cseg
.org 0

              rjmp RESET    ; Reset Handler
              rjmp EXT_INT0 ; IRQ0 Handler
              rjmp EXT_INT1 ; IRQ1 Handler
              rjmp TIM_CAPT1 ; Timer1 Capture Handler
              rjmp TIM_COMP1 ; Timer1 Compare Handler
              rjmp TIM_OVF1 ; Timer1 Overflow Handler
              rjmp TIM_OVF0 ; Timer0 Overflow Handler
              rjmp UART_RXC ; UART RX Complete Handler
              rjmp UART_DRE ; UDR Empty Handler
              rjmp UART_TXC ; UART TX Complete Handler
              rjmp ANA_COMP ; Analog Comparator Handler



EXT_INT0  :	ret
EXT_INT1  :	ret
TIM_CAPT1 :	ret
TIM_OVF0  :	ret
TIM_OVF1  :   ret
UART_RXC  :   ret
UART_DRE  :   ret
UART_TXC  :   ret
ANA_COMP  :   ret
TIM_COMP1 :   ret



reset:        ldi Temp1,RamEnd	; 
              out SPL,Temp1

              cli

              ldi Temp,0b11111111 ; 
              out ddrb,Temp

              ldi Temp,0b00001111
              out ddrd,Temp

              ldi Temp,4
              sts Digit  ,Temp      ;  
              ldi Temp,3
              sts Digit+1,Temp
              ldi Temp,2
              sts Digit+2,Temp
              ldi Temp,1
              sts Digit+3,Temp


;*********************************************************
;MAIN
;*********************************************************

IndicCycle:   rcall Display        ; 
              rjmp IndicCycle

;*********************************************************
Display:
;    
; Digit

              lds Temp1,Digit      ; 0- 
              ldi Temp,0b00001110  ; 0- 
                                   ;
              out PortD,Temp
              rcall Decoder        ; 7-. 
              out PortB,Temp1      ;   
              rcall Delay1         ;

              lds Temp1,Digit+1    ; ..
              ldi Temp,0b00001101
              out PortD,Temp
              rcall Decoder
              out PortB,Temp1
              rcall Delay1

              lds Temp1,Digit+2
              ldi Temp,0b00001011
              out PortD,Temp
              rcall Decoder
              out PortB,Temp1
              rcall Delay1

              lds Temp1,Digit+3
              ldi Temp,0b00000111
              out PortD,Temp
              rcall Decoder
              out PortB,Temp1
              rcall Delay1

              ret


;*********************************************************
Decoder:
;  
;  7- 

              ldi ZL,Low(DcMatrix*2)   ; 
              ldi ZH,High(DcMatrix*2)

              ldi Temp2,0             ; 
              add ZL,Temp1            ; 0-  
              adc ZH,Temp2

              lpm                     ; 
              mov Temp1,r0
              ret

DcMatrix:
; -   
              ;     hgfedcba   hgfedcba
              .db 0b00111111,0b00000110	;0,1
              .db 0b01011011,0b01001111	;2,3
              .db 0b01100110,0b01101101	;4,5
              .db 0b01111101,0b00000111	;6,7
              .db 0b01111111,0b01101111	;8,9

;*********************************************************
Delay1:
; 

              push Temp1
              push Temp2


              ldi Temp1,0
              ldi Temp2,50

d11:          dec Temp1
              brne d11
              dec Temp2
              brne d11

              pop Temp2
              pop Temp1

              ret
